#include "Comp.h"

static HEAP_ALLOC(wrkmem, LZO1X_1_MEM_COMPRESS);

// CUBRID ͺ̽  ϴ  
extern T_CCI_ERROR error;
extern T_CCI_COL_INFO *res_col_info;
extern T_CCI_SQLX_CMD cmd_type;

/***************************************************************
// LZO  ::  ü 
***************************************************************/
int lzo_compress(int fdr)
{
	void* addr_R;
	unsigned char out[CHUNK2];
	unsigned long offset_r, offset_w;
	u_int64_t filesize = 0;
	u_int64_t readsize = 0;
	u_int64_t writesize = 0;
	
	int r;
	int fdw = open64("./RESULT", O_RDWR | O_TRUNC | O_CREAT);

	//  б 
	if( fdr < 0 || fdw < 0 ) {
		printf("File open error\n");
		return(-200);
	}
	
	filesize = lseek64(fdr, 0, SEEK_END);
	lseek64(fdr, 0, SEEK_SET);
	
	// LZO ̺귯 ʱȭ
	if( lzo_init() != LZO_E_OK)
	{
	    printf("internal error - lzo_init() failed !!!\n");
        printf("(this usually indicates a compiler bug - try recompiling\nwithout optimizations, and enable `-DLZO_DEBUG' for diagnostics)\n");
        return -3;
	}
	
	while( readsize < filesize )
	{
		memset(out, '\0', CHUNK2);
		if( readsize + CHUNK < filesize ) 
			offset_r = CHUNK;
		else
			offset_r = filesize - readsize;
		
		// MMAP   б
		addr_R = mmap64(0, offset_r, PROT_READ, MAP_SHARED, fdr, readsize);
		offset_w = CHUNK2;
		
		// LZO   Լ 
		r = lzo1x_1_compress((const unsigned char*)addr_R, offset_r, out, &offset_w, wrkmem);
		
		if (r == LZO_E_OK)
		{
			//  
			; //printf("compressed %lu bytes into %lu bytes\n", (unsigned long) offset_r, (unsigned long) offset_w);
		}
		else
		{
			//  
			/* this should NEVER happen */
			printf("internal error - compression failed: %d\n", r);
			return -2;
		}
		
		/* check for an incompressible block */
		if (offset_w >= offset_r)
		{
			//  
			; //printf("This block contains incompressible data.\n");
			//return -1;
		}
				
		// writing file
		write(fdw, out, offset_w);
		writesize += offset_w;
		
		// memory de-llocate
		munmap(addr_R, offset_r);
		readsize += CHUNK;
	}
	
	return(1);
}

/***************************************************************
// ZLIB  - GZ ::  ü 
***************************************************************/
int zlib_compress(int fdr)
{
	// ʱȭ
	void* addr_R;
	int err;
	
	unsigned char out[CHUNK2];
	unsigned long offset_r, offset_w;
	u_int64_t filesize = 0;
	u_int64_t readsize = 0;
	u_int64_t writesize = 0;
		
	int fdw = open64("./RESULT", O_RDWR | O_TRUNC | O_CREAT);

	// error confirm
	if( fdr < 0 || fdw < 0 ) {
		printf("File open error\n");
		return(-200);
	}
	
	filesize = lseek64(fdr, 0, SEEK_END);
	lseek64(fdr, 0, SEEK_SET);
	
	while( readsize < filesize )
	{
		memset(out, '\0', CHUNK2);
		if( readsize + CHUNK < filesize ) 
			offset_r = CHUNK;
		else
			offset_r = filesize - readsize;
		
		//  б
		addr_R = mmap64(0, offset_r, PROT_READ, MAP_SHARED, fdr, readsize);
		offset_w = CHUNK2;

		// zlib Compress
		err = compress(out, &offset_w, (const Bytef*)addr_R, offset_r);
		CHECK_ERR_RETURN(err, "compress");
				
		// writing file
		write(fdw, out, offset_w);
		writesize += offset_w;
		
		// memory de-llocate
		munmap(addr_R, offset_r);
		readsize += CHUNK;
	}
	
	return(1);
}

/***************************************************************
// BZ2  ::  ü 
***************************************************************/
int bz2_compress(int fdr)
{
	// BZ2  ̽ MMAP  
	int BZ2;
	
	char out[CHUNK2];
	char in[CHUNK2];
	unsigned int offset_r, offset_w;
	u_int64_t filesize = 0;
	u_int64_t readsize = 0;
		
	int fdw = open64("./RESULT", O_RDWR | O_TRUNC | O_CREAT);

	// error confirm
	if( fdr < 0 || fdw < 0 ) {
		printf("File open error\n");
		return(-200);
	}
	
	filesize = lseek64(fdr, 0, SEEK_END);
	lseek64(fdr, 0, SEEK_SET);

	while( readsize < filesize )
	{
		memset(out, '\0', CHUNK2);
		memset(in, '\0', CHUNK2);
		if( readsize + CHUNK < filesize ) 
			offset_r = CHUNK;
		else
			offset_r = filesize - readsize;
		
		// zlib Compress
		lseek(fdr, readsize, offset_r);
		read(fdr, in, offset_r);
		offset_w = CHUNK2;

		BZ2 = BZ2_bzBuffToBuffCompress( out, &offset_w, in, offset_r, 9, 0, 9);


		if( BZ2 == BZ_OUTBUFF_FULL)
		{
			write(fdw, in, offset_r);
		}
		
		if( BZ2 == BZ_OK )
		{
			write(fdw, out, offset_w);
		}
		readsize += CHUNK;
	}
	
	return(1);
}


/***************************************************************
// Zlib Compress of Block unit
***************************************************************/
int Zlib_Blk_Comp(int fdr, int fdw, char* fhash)
{
	char buf[300];
	char hash[40];
	unsigned char out[CHUNK2];
	unsigned char in[CHUNK2];

	int err;
	int dep=0;
	u_int64_t offset = 0;
	u_int64_t repooffset = 0;
	unsigned long offset_w= 0;
	int BlockSize = 0;

	lseek64(fdr, 0, SEEK_SET);
	repooffset = lseek64(fdw, 0, SEEK_END);
	
	FILE *stream;
	stream = fopen("./READMETA", "rt");
	
	// DATABASE 
	int con;
	con = Curbrid_Connection();
	
	while(1)
	{
		memset(buf, '\0', 300);
		memset(hash, '\0', 40);
		memset(out, '\0', CHUNK2);
		memset(in, '\0', CHUNK2);
	
		// METADATA  
		// LINE 
		if ( fgets(buf, 300, stream) != NULL)
		{
			// buf scan
			sscanf(buf, "%40s:%llu:%d:%d ", hash, &offset, &BlockSize, &dep);
			
			//   ̵
			lseek(fdr, offset, SEEK_SET);
			read(fdr, in, BlockSize);

			// zlib Compress
			offset_w = CHUNK2;
			err = compress(out, &offset_w, in, BlockSize);
			CHECK_ERR_RETURN(err, "compress");
			
			// DB insert
			// ߺ ƴҶ
			if( dep == 1 )	
			{
				BlockInfoDBSave(hash, repooffset, offset_w, con);
			}
			
			//  쿡
			RestoreInfoDBSave(fhash, hash, repooffset,  con);

			// writing file
			write(fdw, out, offset_w);
			repooffset+=offset_w;
		}
		else
		{
			// loop exit,  
			break;
		}
	}

	// DATABASE 
	Cubrid_DisConnection(con);

	fclose(stream);
	return(1);
}

/***************************************************************
// Bzip2 Compress of Block unit
***************************************************************/
int Bz2_Blk_Comp(int fdr, int fdw)
{
	char buf[300];
	char hash[40];
	char out[CHUNK2];
	char in[CHUNK2];

	int BZ2;
	u_int64_t offset = 0;
	unsigned int offset_w= 0;
	int BlockSize = 0;

	lseek64(fdr, 0, SEEK_SET);

	FILE *stream;
	stream = fopen("./READMETA", "rt");

	while(1)
	{
		memset(buf, '\0', 300);
		memset(hash, '\0', 40);
		memset(out, '\0', CHUNK2);
		memset(in, '\0', CHUNK2);
		
		if ( fgets(buf, 300, stream) != NULL)
		{
			sscanf(buf, "%40s:%llu:%d ", hash, &offset, &BlockSize);
			
			lseek(fdr, offset, BlockSize);
			read(fdr, in, BlockSize);

			// init
			offset_w = CHUNK2;

			BZ2 = BZ2_bzBuffToBuffCompress( out, &offset_w, in, BlockSize, 1, 0, 30);

			if( BZ2 == BZ_OUTBUFF_FULL)
			{
				memset(out, '\0', CHUNK2);
			}
			
			if (offset_w >= (u_int64_t)BlockSize)
			{
				; //printf("This block contains incompressible data.\n");
				//return -1;
			}

			// writing file
			write(fdw, out, offset_w);
		}
		else
		{
			// loop exit,  
			break;
		}
	}

	fclose(stream);
	return(1);
}

/***************************************************************
// Lzo Compress of Block unit
***************************************************************/
int Lzo_Blk_Comp(int fdr, int fdw)
{
	// char buffer
	char buf[300];
	char hash[40];
	unsigned char out[CHUNK2];
	unsigned char in[CHUNK2];

	// count
	int r;
	u_int64_t offset = 0;
	unsigned long offset_w= 0;
	int BlockSize = 0;

	lseek64(fdr, 0, SEEK_SET);

	FILE *stream;
	stream = fopen("./READMETA", "rt");

	while(1)
	{
		memset(buf, '\0', 300);
		memset(hash, '\0', 40);
		memset(out, '\0', CHUNK2);
		memset(in, '\0', CHUNK2);
		
		if ( fgets(buf, 300, stream) != NULL)
		{
			// buf scan
			sscanf(buf, "%40s:%llu:%d ", hash, &offset, &BlockSize);
			
			// read Block
			lseek(fdr, offset, SEEK_SET);
			read(fdr, in, BlockSize);

			// init
			offset_w = CHUNK2;

			r = lzo1x_1_compress(in, BlockSize, out, &offset_w, wrkmem);

			if (r == LZO_E_OK)
			{
				; //printf("compressed %lu bytes into %lu bytes\n", (unsigned long) offset_r, (unsigned long) offset_w);
			}
			else
			{
				/* this should NEVER happen */
				printf("internal error - compression failed: %d\n", r);
				return -2;
			}
			
			/* check for an incompressible block */
			if (offset_w > (u_int64_t)BlockSize)
			{
				//printf("This block contains incompressible data.\n");
				//write(fdw, (char *)addr_R, BlockSize);
				//return -1;
			}

			// writing file
			write(fdw, out, offset_w);
		}
		else
		{
			// loop exit
			break;
		}
	}

	fclose(stream);
	return(1);
}

/***************************************************************
//   
***************************************************************/
int Plain(int fdr, int fdw)
{
	// char buffer
	char buf[300];
	char hash[40];
	unsigned char in[CHUNK2];

	// count
	u_int64_t offset = 0;
	int BlockSize = 0;

	lseek64(fdr, 0, SEEK_SET);

	FILE *stream;
	stream = fopen("./READMETA", "rt");

	while(1)
	{
		memset(buf, '\0', 300);
		memset(hash, '\0', 40);
		memset(in, '\0', CHUNK2);
		
		if ( fgets(buf, 300, stream) != NULL)
		{
			// buf scan
			sscanf(buf, "%40s:%llu:%d ", hash, &offset, &BlockSize);
			
			// mmap
			lseek(fdr, offset, SEEK_SET);
			read(fdr, in, BlockSize);

			// writing file
			write(fdw, in, BlockSize);
		}
		else
		{
			// loop exit
			break;
		}
	}

	fclose(stream);
	return(1);
}

/***************************************************************
//    ִ Ÿ͸ 
// ͺ̽ 
***************************************************************/
int RestoreInfoDBSave(char* fhash, char* blk_sha1, u_int64_t pos, int con)
{
	int req = 0, res = 0;

	char buf[500];
	char query[500];
	
	memset(buf, '\0', 500);
	memset(query, '\0', 500);

	//  ۼ
	sprintf(query, "insert into restorefile(fhash, blocksha1, bidx ) values( '%s', '%s', %llu )", fhash, blk_sha1, pos );

	if ((req=cci_prepare(con, query, 0,&error))<0) {
		printf( "%s(%d): cci_prepare fail(%d)\n", __FILE__, __LINE__,error.err_code);
	}
    
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("excute error\n");

		assert(cci_end_tran(con, CCI_TRAN_ROLLBACK, &error) < 0);
	}

	assert(cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0);
	
    return 0;
}

/***************************************************************
//   ͺ̽ 
***************************************************************/
int BlockInfoDBSave(char* blk_sha1, u_int64_t pos, int length, int con)
{
	int req = 0, res = 0;
	
	char buf[500];
	char query[500];
	
	memset(buf, '\0', 500);
	memset(query, '\0', 500);

	//  ۼ
	sprintf(query, "insert into block(blocksha1, blockrabin, pos, blength, path) values( '%s', %llu, %llu, %d, '%s'  )", blk_sha1, 0LL, pos, length, "/public/program/owlserver/REPO/" );

	if ((req=cci_prepare(con, query, 0,&error))<0) {
		printf( "%s(%d): cci_prepare fail(%d)\n", __FILE__, __LINE__,error.err_code);
	}
    
	if ((res = cci_execute(req, 0, 0, &error)) < 0) {
		printf("excute error\n");

		assert(cci_end_tran(con, CCI_TRAN_ROLLBACK, &error) < 0);
	}

	assert(cci_end_tran(con, CCI_TRAN_COMMIT, &error) < 0);	

    return 0;
}

/***************************************************************
// ׽Ʈ Լ 
//    Ǵ    
***************************************************************/
void test_compress()
{
	int fd;
	int fd2;
	int err;
	int readcnt=240;
	unsigned char out[10000];

	Byte buf[10000];
	memset(buf, '\0', 10000);

	assert((fd = open("./REPO/Result", O_RDONLY , 0644)) > 0);
	readcnt = read(fd, buf, readcnt);
	
	uLong len = readcnt;
	uLong comprLen = 10000;

	err = uncompress(out, &comprLen, buf, len);
	CHECK_ERR(err, "uncompress");

	//   Ͼ Ȯ   ִ.
	assert((fd2 = open("./REPO/test_result", O_WRONLY | O_CREAT | O_TRUNC, 0644)) > 0);
	
	write(fd2, buf, len);

	close(fd);
	close(fd2);
}
