#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <time.h>

// bz2
#include "bzlib.h"
// zlib
#include "zlib.h"
// lzo
#include "./minilzo/minilzo.h"

// DB
#include "main.h"

#define PACKAGE "mmap"
#define CHUNK 	8192
#define CHUNK2 	16384

#define CHECK_ERR(err, msg) { \
	if ( err != Z_OK ) { \
		fprintf(stderr, "%s error: %d\n", msg, err); \
		exit(1); \
	} \
}

#define CHECK_ERR_RETURN(err, msg) { \
	if ( err != Z_OK ) { \
		fprintf(stderr, "%s error: %d\n", msg, err); \
		return(err); \
	} \
}

#define HEAP_ALLOC(var,size) \
    lzo_align_t __LZO_MMODEL var [ ((size) + (sizeof(lzo_align_t) - 1)) / sizeof(lzo_align_t) ]

int zlib_compress(int fdr);
int lzo_compress(int fdr);
int bz2_compress(int fdr);
int Zlib_Blk_Comp(int fdr, int fdw, char* fhash);
int Bz2_Blk_Comp(int fdr, int fdw);
int Lzo_Blk_Comp(int fdr, int fdw);
int Plain(int fdr, int fdw);
int BlockInfoDBSave(char* blk_sha1, u_int64_t pos, int length, int con);
int RestoreInfoDBSave(char* fhash, char* blk_sha1, u_int64_t pos, int con);
void test_compress();