#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>		// for 'read/close'
#include <sys/types.h>	// for 'open'
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>		// for 'isprint'
#include <sys/time.h>	// for 'gettimeofday'
#include "rabinpoly.h"
#include "hash.h"
#include "Comp.h"
#include "red_black_tree.h"

#define FINGERPRINT_PT	0xbfe6b8a5bf378d83LL
#define CHUNK_SIZE		8192

/* -------------------------------------------------------
	global variable
------------------------------------------------------- */
extern rb_red_blk_tree* SHA1tree;
extern rb_red_blk_tree* Rabintree;

//extern window myRabin(FINGERPRINT_PT, CHUNK_SIZE);
extern int Chunk_Count;
extern struct timeval start, end;


extern void UInt64Dest(void* a);
extern int UInt64Comp(const void* a,const void* b);
extern void UInt64Print(const void* a);
extern int cmp(const void* a, const void* b);
extern int HashComp(const void* a,const void* b);
extern int Hashcpy(const void* a,const void* b);
extern void HashPrint(const void* a);
extern void InfoPrint(void* a);
extern void InfoDest(void *a);
extern void HashDest(void* a);
extern u_int64_t RabinBlockHash(unsigned char *buf);
extern u_int64_t RabinVBlockHash(unsigned char *buf, int size);
extern u_int64_t RabinVBlockHash(unsigned char *buf, int size);
extern u_int64_t RabinVariableHash(unsigned char *buf, int size);
extern int FindSHA1(unsigned char* SFP);
extern int FindRabin(u_int64_t SFP);
extern void InsertSHA1(unsigned char* SFP);
extern void InsertRabin(u_int64_t SFP);
extern void NodupInsertSHA1(unsigned char* SFP);
extern void NodupInsertRabin(u_int64_t SFP);
extern void DBC_FS(int fdr);
extern int SlideVerify(unsigned char *window1, unsigned char *sha1sum_back, int size, int *k, u_int64_t *raf);
extern int VerifyHash(unsigned char* buf, unsigned char *sha1sum, int size, u_int64_t* ra );
extern void WriteLog(int fdmw, u_int64_t rabinf, unsigned char * sha1, u_int64_t offset, int size);
extern int VerifyFixedBlock(u_int64_t *offset, 
				 u_int64_t filesize, 
				 int fdr,
				 int fdmw,
				 unsigned char *buf, 
				 unsigned char *sha1sum,
				 u_int64_t *rabinf,
				 int *chunk_ref_count);
extern int VerifyStrideBlock(unsigned char *window1,
						unsigned char *buf,
						unsigned char *buf1,
						unsigned char *sha1sum_back,
						unsigned char *sha1sum,
						u_int64_t *rabinp,
						u_int64_t *rabinf,
						u_int64_t *offset,
						u_int64_t filesize,
						int fdmw,
						int fdr,
						int stride);

extern int VerifyISSFixedBlock(u_int64_t *offset, 
				 u_int64_t filesize, 
				 int fdr,
				 int fdmw,
				 unsigned char *buf, 
				 unsigned char *sha1sum,
				 u_int64_t *rabinf,
				 int *chunk_ref_count,
				 int stride);

extern int VerifyISSBlock(unsigned char *window1,
						unsigned char *buf,
						unsigned char *buf1,
						unsigned char *sha1sum_back,
						unsigned char *sha1sum,
						u_int64_t *rabinp,
						u_int64_t *rabinf,
						u_int64_t *offset,
						u_int64_t filesize,
						int fdmw,
						int fdr,
						int stride);


extern int VerifyTailBlock(unsigned char *window1,
						unsigned char *sha1sum_back,
						unsigned char *sha1sum,
						unsigned char *buf,
						unsigned char *buf1,
						u_int64_t *rabinp,
						u_int64_t *rabinf,
						u_int64_t *offset,
						u_int64_t filesize,
						int fdmw,
						int fdr 
						);
extern void VerifyBackTracking(u_int64_t offset,
						u_int64_t filesize,
						u_int64_t localtemp,
						int fdmw,
						int fdr,
						int stride
						);

extern void DBC_ISS(int fdr, int stride);
extern void DBC_SS(int fdr, int stride);
extern void DBC_BS(int fdr);