#include "main.h"
#include "FD2E.h"

void UInt64Dest(void* a);
int UInt64Comp(const void* a,const void* b);
void UInt64Print(const void* a);
int cmp(const void* a, const void* b);
int HashComp(const void* a,const void* b);
int Hashcpy(const void* a,const void* b);
void HashPrint(const void* a);
void InfoPrint(void* a);
void InfoDest(void *a);
void HashDest(void* a);
u_int64_t RabinBlockHash(unsigned char *buf);
u_int64_t RabinVBlockHash(unsigned char *buf, int size);
u_int64_t RabinVBlockHash(unsigned char *buf, int size);
u_int64_t RabinVariableHash(unsigned char *buf, int size);
int FindSHA1(unsigned char* SFP);
int FindRabin(u_int64_t SFP);
void InsertSHA1(unsigned char* SFP);
void InsertRabin(u_int64_t SFP);
void NodupInsertSHA1(unsigned char* SFP);
void NodupInsertRabin(u_int64_t SFP);
void DBC_FS(int fdr);
int SlideVerify(unsigned char *window1, unsigned char *sha1sum_back, int size, int *k, u_int64_t *raf);
int VerifyHash(unsigned char* buf, unsigned char *sha1sum, int size, u_int64_t* ra );
void WriteLog(int fdmw, u_int64_t rabinf, unsigned char * sha1, u_int64_t offset, int size);
void DBC_ISS(int fdr, int stride);
void DBC_SS(int fdr, int stride);
void DBC_BS(int fdr);

clnt g_clntent[MAX_CLIENT];
pthread_t thread_for_event;
void* thread_result_for_event;

int g_device_status;    
int g_epoll_fd;                 
int g_serv_sockfd;              
int g_serv_port;                
struct epoll_event g_events[MAX_CLIENT];

int main(int argc, char** argv)
{
	//Ŭ̾Ʈ   Ÿ͸ ٿ ޴´.
	
	int cnt = 0;
	int sigState;			//ñ׳  ¸ ϴ 
	struct sigaction act;	// ñ׳ ó  ü  

	// DB Select query
	int nColCount = 0, nLen = 0;
    int i = 0, nDB = 0, nReq = 0, j=0; 
	char *pszBuff = NULL;	

	unsigned char upper[] = { 0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70, 0x80, 0x90, 0xa0, 0xb0, 0xc0, 0xd0, 0xe0, 0xf0};
	unsigned char lower[] = { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f};
	
	T_CCI_ERROR cciErr;
    T_CCI_COL_INFO *pcciCol;
    T_CCI_SQLX_CMD cciCmdType;

	act.sa_handler = end_server;	//ñ׳ Լ 
	sigemptyset(&act.sa_mask);		
	act.sa_flags = 0;
	sigState = sigaction(SIGINT, &act, 0);	// ñ׳ (Ctrl+C)  α׷  Լ ȣ (end_Server ȣ)

	//test_compress();
	//return 1;

	//ñ׳  ϸ α׷ Ѵ.
	if(sigState != 0)
	{
		printf("[OWL] Signal state fails\n");
		exit(0);
	}

	printf("[OWL][START] epoll test server v1.0 (simple epoll test server)\n");

	if(argc < 3)
	{
		g_serv_port = DEFAULT_PORT;			//Ʈ Ʈ ̿Ͽ  ּҸ ε 
	}
	else
	{
		if(strcmp("-port", argv[1]) == 0)	//Ʈ Ʈ  ʰ ٸ Ʈ  
		{
			g_serv_port = atoi(argv[2]);	// -port ɼ ̿Ͽ Ʈ 
		}
	}

	init_data();				// ʱȭ, α׷ Ҷ  ͸ ʱȭ
	init_server(g_serv_port);	//  , ּ ε, Ŭ̾Ʈ  
	epoll_init();				//̺Ʈ    ʱȭ

	printf("[OWL] HASHTREE INITALIZING....\n");
	SHA1tree = RBTreeCreate(HashComp, HashDest, InfoDest, HashPrint, InfoPrint);
	Rabintree = RBTreeCreate(UInt64Comp, UInt64Dest, InfoDest, UInt64Print, InfoPrint);
	
    assert((nDB = cci_connect("210.115.226.88", 30000, "owl", "DBA", "azws")) >= 0);
    assert((nReq = cci_prepare(nDB, "SELECT blocksha1 FROM block", 0, &cciErr)) >= 0);
    assert((pcciCol = cci_get_result_info(nReq, &cciCmdType, &nColCount)) != NULL);
    assert(cci_execute(nReq, 0, 0, &cciErr) >= 0);
	
    while (1) 
    {
        if ( cci_cursor(nReq, 1, CCI_CURSOR_CURRENT, &cciErr) == CCI_ER_NO_MORE_DATA )
            break;
       
        assert(cci_fetch(nReq, &cciErr) >= 0);
       
        for (i = 1; i<= nColCount; i++)
        {
			assert(cci_get_data(nReq, i, CCI_A_TYPE_STR, &pszBuff, &nLen) >= 0);
            
			unsigned char *tempBuff = (unsigned char *)malloc(20);
            memset(tempBuff, '\0', 20);

			for( j=0; j<20; j++)
			{				
				int up, low;

                up = hexconvert(pszBuff[j*2]);
                low = hexconvert(pszBuff[j*2+1]);

			
				tempBuff[j] = upper[up] + lower[low];
			}
			cnt++;
			InsertSHA1(tempBuff);
        }
        

    }
	printf("[OWL] HASHTREE LOADING : %d\n", cnt);
	printf("[OWL] HASHTREE LOADING SUCCESS....\n");

    assert(cci_close_req_handle(nReq) >= 0);
    assert(cci_disconnect(nDB, &cciErr) >= 0);

	while(1)
	{
		// ó Ͼ  , <<Ŭ̾Ʈ  û ޴ 帧>>
		server_process();		
	}

	return 0;
}

char hexconvert(char ch)
{
        switch(ch)
        {
                case '0':
                        return 0;
                        break;
                case '1':
                        return 1;
                        break;
                case '2':
                        return 2;
                        break;
                case '3':
                        return 3;
                        break;
                case '4':
                        return 4;
                        break;
                case '5':
                        return 5;
                        break;
                case '6':
                        return 6;
                        break;
                case '7':
                        return 7;
                        break;
                case '8':
                        return 8;
                        break;
                case '9':
                        return 9;
						break;
				case 'A':
                        return 10;
                        break;
                case 'B':
                        return 11;
                        break;
                case 'C':
                        return 12;
                        break;
                case 'D':
                        return 13;
                        break;
                case 'E':
                        return 14;
                        break;
                case 'F':
                        return 15;
                        break;
		}

		return -1;
}



// ñ׳  Լ -  
void
end_server(int sig)
{
	close(g_epoll_fd);		//̺Ʈ  
	close(g_serv_sockfd);	// 
	//MySQL_Close();			// ̽  
	printf("[OWL][SHUTDOWN] Server Closed by signal %d\n", sig);
	exit(0);
}

